#include <bits/stdc++.h>

using namespace std;


long long a[100020];
long long b[100020];
long long c[100020];

int main()
{
    long long n,h,i,s=0,first=0;
    cin>>h>>n;
    for(int i=1;i<=n;i++)
        c[i]=1;
    for(int i=1;i<=h;i++)
    {
        for(int j=1;j<=n;j++)
            cin>>b[j];
        s=0;
        first=0;
        for(int j=1;j<=n;j++)
        {
            a[j]=c[j];
            c[j]=0;
            //cout<<a[i];
        }
        for(int j=1;j<=n;j++)
        {
            if(b[j]==0)
            {
                if(first)
                {
                    s=s+a[j];
                }
                else{
                    first=j;
                    s=a[j];
                }
                if(j==n)
                    c[first-1]=c[first-1]+s;
            }
            else{
                if(first==1)
                {
                    c[j]=c[j]+s+a[j];
                    s=0;
                    first=0;
                }
                else{
                    if(s%2==1)
                    {
                        if(i%2==0)
                        {
                            c[j]=c[j]+s/2+1+a[j];
                            c[first-1]=c[first-1]+s/2;
                            s=0;
                            first=0;
                        }
                        else{
                            c[j]=c[j]+s/2+a[j];
                            c[first-1]=c[first-1]+s/2+1;
                            s=0;
                            first=0;
                        }

                    }
                    else{
                        c[j]=c[j]+s/2+a[j];
                        c[first-1]=c[first-1]+s/2;
                        s=0;
                        first=0;
                    }
                }
            }
        }
        //for(int j=1;j<=n;j++)
         //   cout<<c[j];
        //cout<<endl;
    }
    for(int i=1;i<=n;i++)
        cout<<c[i]<<" ";
    return 0;
}